{    Web-   HTML.
   ""    -,   
Ctrl-S.      

:    ilia@valley.ru}
unit HTMLedit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, ComCtrls, Menus, Grids, IniFiles;

const
 IniFileName = 'HTMLEditor.ini';

type
  TfmMain = class(TForm)
    Menu: TMainMenu;
    pnlMenu: TPanel;
    Open: TOpenDialog;
    Save: TSaveDialog;
    sbOpen: TSpeedButton;
    sbSave: TSpeedButton;
    sbCancel: TSpeedButton;
    sbCopy: TSpeedButton;
    sbCut: TSpeedButton;
    sbPaste: TSpeedButton;
    Bevel1: TBevel;
    mFile: TMenuItem;
    Bevel2: TBevel;
    Bevel3: TBevel;
    miOpen: TMenuItem;
    miSave: TMenuItem;
    miSaveAs: TMenuItem;
    miSep1: TMenuItem;
    miExit: TMenuItem;
    mEdition: TMenuItem;
    miCopy: TMenuItem;
    miCut: TMenuItem;
    miPaste: TMenuItem;
    miSep2: TMenuItem;
    miSelectAll: TMenuItem;
    miClear: TMenuItem;
    miCancel: TMenuItem;
    mAbout: TMenuItem;
    miSep3: TMenuItem;
    mOptions: TMenuItem;
    miShowHints: TMenuItem;
    miShowTools: TMenuItem;
    miAbout: TMenuItem;
    sbStatus: TStatusBar;
    dlgColor: TColorDialog;
    mService: TMenuItem;
    miFileIns: TMenuItem;
    dlgFileIns: TOpenDialog;
    miColorIns: TMenuItem;
    mmInput: TMemo;
    Bevel4: TBevel;
    sbFNameIns: TSpeedButton;
    sbColorIns: TSpeedButton;
    sbFontIns: TSpeedButton;
    miFontIns: TMenuItem;
    procedure sbCopyClick(Sender: TObject);
    procedure sbCutClick(Sender: TObject);
    procedure sbPasteClick(Sender: TObject);
    procedure sbCancelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure miCancelClick(Sender: TObject);
    procedure miCopyClick(Sender: TObject);
    procedure miCutClick(Sender: TObject);
    procedure miPasteClick(Sender: TObject);
    procedure miSelectAllClick(Sender: TObject);
    procedure miClearClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure miShowHintsClick(Sender: TObject);
    procedure miShowToolsClick(Sender: TObject);
    procedure sbOpenClick(Sender: TObject);
    procedure sbSaveClick(Sender: TObject);
    procedure miOpenClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);
    procedure miSaveAsClick(Sender: TObject);
    procedure miFileInsClick(Sender: TObject);
    procedure miColorInsClick(Sender: TObject);
    procedure sbFNameInsClick(Sender: TObject);
    procedure sbColorInsClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure sbFontInsClick(Sender: TObject);
    procedure miFontInsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    StartLines: TStringList;
    FName: String;
    procedure GetPos(SearchFor: String; var i , j: Integer);
    function ColorToHex(Color: TColor): String;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

uses About, FontDlg;

{$R *.DFM}

procedure TfmMain.sbCopyClick(Sender: TObject);
begin
 mmInput.CopyToClipboard;
end;

procedure TfmMain.sbCutClick(Sender: TObject);
begin
 mmInput.CutToClipboard;
end;

procedure TfmMain.sbPasteClick(Sender: TObject);
begin
 mmInput.PasteFromClipboard;
end;

procedure TfmMain.sbCancelClick(Sender: TObject);
begin
 If mmInput.Perform(EM_CANUNDO,0,0) <> 0 then
  mmInput.Perform(EM_UNDO,0,0);
end;

procedure TfmMain.FormCreate(Sender: TObject);
var
 Ini: TIniFile;
begin
 Application.ShowHint:=True;
 FName:='';
 Ini:=TIniFile.Create(ExtractFilePath(ParamStr(0))+IniFileName);
 Open.InitialDir:=Ini.ReadString('Files','Path','C:\ \');
 Ini.Free;
end;

procedure TfmMain.miCancelClick(Sender: TObject);
begin
 sbCancelClick(Self);
end;

procedure TfmMain.miCopyClick(Sender: TObject);
begin
 sbCopyClick(Self);
end;

procedure TfmMain.miCutClick(Sender: TObject);
begin
 sbCutClick(Self);
end;

procedure TfmMain.miPasteClick(Sender: TObject);
begin
 sbPasteClick(Self);
end;

procedure TfmMain.miSelectAllClick(Sender: TObject);
begin
 mmInput.SelectAll;
end;

procedure TfmMain.miClearClick(Sender: TObject);
begin
 mmInput.Clear;
 mmInput.Lines.Assign(StartLines);
end;

procedure TfmMain.miAboutClick(Sender: TObject);
begin
 AboutBox.ShowModal;
end;

procedure TfmMain.miShowHintsClick(Sender: TObject);
begin
 miShowHints.Checked:=not miShowHints.Checked;
 Application.ShowHint:=not Application.ShowHint;
end;

procedure TfmMain.miShowToolsClick(Sender: TObject);
begin
 miShowTools.Checked:=not miShowTools.Checked;
 pnlMenu.Visible:=not pnlMenu.Visible;
end;

procedure TfmMain.sbOpenClick(Sender: TObject);
begin
 If Open.Execute and FileExists(Open.FileName) then
  begin
   Open.InitialDir:=ExtractFilePath(Open.FileName);
   mmInput.Lines.LoadFromFile(Open.FileName);
   sbStatus.SimpleText:=Open.FileName;
   FName:=Open.FileName;
  end;
end;

procedure TfmMain.sbSaveClick(Sender: TObject);
begin
 If FName = '' then
  begin
   If Save.Execute then
    begin
     mmInput.Lines.SaveToFile(Save.FileName);
     FName:=Save.FileName;
    end
  end
 else
  mmInput.Lines.SaveToFile(FName);
end;

procedure TfmMain.miOpenClick(Sender: TObject);
begin
 sbOpenClick(Self);
end;

procedure TfmMain.miSaveClick(Sender: TObject);
begin
 sbSaveClick(Self);
end;

procedure TfmMain.miSaveAsClick(Sender: TObject);
begin
 If Save.Execute then
  mmInput.Lines.SaveToFile(Save.FileName);
end;

procedure TfmMain.miFileInsClick(Sender: TObject);
var
 CharPosI , CharPosJ: Integer;
 S: String;
begin
 If dlgFileIns.Execute then
  begin
   GetPos('""',CharPosI,CharPosJ);
   If CharPosJ <> 0 then
    begin
     S:=mmInput.Lines.Strings[CharPosI];
     Insert(dlgFileIns.FileName,S,CharPosJ+1);
     mmInput.Lines.Strings[CharPosI]:=S;
    end;
  end;
end;

procedure TfmMain.GetPos(SearchFor: String; var i , j: Integer);
var
 k: Integer;
 Position: Integer;
 S: String;
begin
 i:=0;
 j:=0;
 For k:=1 to mmInput.Lines.Count-1 do
  begin
   S:=mmInput.Lines.Strings[k];
   Position:=Pos(SearchFor,S);
   If Position <> 0 then
    begin
     j:=Position;
     i:=k;
     Break;
    end;
  end;
end;

procedure TfmMain.miColorInsClick(Sender: TObject);
var
 CharPosI , CharPosJ: Integer;
 S: String;
begin
 If dlgColor.Execute then
  begin
   GetPos('""',CharPosI,CharPosJ);
   If CharPosJ <> 0 then
    begin
     S:=mmInput.Lines.Strings[CharPosI];
     Insert('#'+ColorToHex(dlgColor.Color),S,CharPosJ+1);
     mmInput.Lines.Strings[CharPosI]:=S;
    end;
  end;
end;

procedure TfmMain.sbFNameInsClick(Sender: TObject);
begin
 miFileInsClick(Self);
end;

procedure TfmMain.sbColorInsClick(Sender: TObject);
begin
 miColorInsClick(Self);
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
 StartLines:=TStringList.Create;
 StartLines.Assign(mmInput.Lines);
end;

function TfmMain.ColorToHex(Color: TColor): String;
var
 R, G, B: Byte;
begin
 Color:=ColorToRGB(Color);
 R:=GetRValue(Color);
 G:=GetGValue(Color);
 B:=GetBValue(Color);
 ColorToHex:=IntToHex(R,2)+IntToHex(G,2)+IntToHex(B,2);
end;

procedure TfmMain.sbFontInsClick(Sender: TObject);
var
 PosI, PosJ: Integer;
 S, InsS: String;
begin
 If fmDlgFont.Execute then
  begin
   GetPos('|',PosI,PosJ);
   If PosJ <> 0 then
    begin
     S:=mmInput.Lines.Strings[PosI];
     Delete(S,PosJ,1);
     InsS:='';
     With fmDlgFont.SelFont do
      begin
       InsS:='face = "'+Name+'" '+'size = "'+IntToStr(Size)+'"';
       If fmDlgFont.FontColSel then
        InsS:=InsS+' color = "#'+ColorToHex(Color)+'"';
      end;
     Insert(InsS,S,PosJ);
     mmInput.Lines.Strings[PosI]:=S;
    end;
  end;
end;

procedure TfmMain.miFontInsClick(Sender: TObject);
begin
 sbFontInsClick(Self);
end;

procedure TfmMain.FormDestroy(Sender: TObject);
var
 Ini: TIniFile;
begin
 Ini:=TIniFile.Create(ExtractFilePath(ParamStr(0))+IniFileName);
 Ini.WriteString('Files','Path',Open.InitialDir);
 Ini.Free;
end;

end.
